// ---------------------------------------------------------------
// LodeRunner GBA
// Level Editor V0.1 27Dec2002
// you must have "fltk-1.1.0rc5" to compile
// ---------------------------------------------------------------

#include <FL/forms.H> // changed for fltk
#include <FL/Fl_File_Chooser.H>
#include <FL/glut.H>	// changed for fltk
#include <FL/Fl_Output.H>

static int border = 1; // changed from FL_TRANSIENT for fltk // (this is so the close box and Esc work to close the window)

Fl_File_Chooser		*fc; 

static GLint viewport[4];

#define EDIT_WINDOW_WIDTH 800 
#define EDIT_WINDOW_HEIGH 600

int id_image;

#define EXIT {fclose(fichier); printf("##Error## in load_image\n"); return -1;}
#define CTOI(C) (*(int*)&C)	//rcupre en int un nombre point par un char*

void fc_callback(Fl_File_Chooser* fc,	void* data);

char  filechoosen[256];

int actual_mouse_posx;  // Position of mouse cursor in pixel units (0 to size of window)
int actual_mouse_posy;

int actual_cell_x;    // Position of cursor in cell unit (32x32 pixels see BS)
int actual_cell_y;  

int gmed_actual_scroll_cell_x=0;    // Position in cell (32x32 pixels)
int gmed_actual_scroll_cell_y=0;  

int bmed_actual_scroll_cell_x=0;    // Position in cell (32x32 pixels)
int bmed_actual_scroll_cell_y=0;  

unsigned char actual_choosen_tile=0;  // Choosen tile (0-255)

FL_FORM*	form;
Fl_Widget*	tobj[50], *exitob, *btypeob, *modeob;

FL_FORM*	  gmed_form;
Fl_Widget*	gmed_obj[50];
#define BS 32

#define FILENAME_SIZESMALL  128
#define FILENAME_SIZEMEDIUM 256

//
// LEVEL FILE
// (Only names and parameters of level)


char  gamemap_name[FILENAME_SIZESMALL];
char  backgroundmap_name[FILENAME_SIZESMALL];
char  gamestyle_name[FILENAME_SIZESMALL];
char  backgroundstyle_name[FILENAME_SIZESMALL];
char  backcolormap_name[FILENAME_SIZESMALL];
char  level_name[FILENAME_SIZEMEDIUM];
unsigned char time;
unsigned char mode;
unsigned char difficulty;

//
// GAME MAP ("GMED")
// 

#define GAMEMAP_WIDTH 80
#define GAMEMAP_HEIGH 64

unsigned char gamemap[GAMEMAP_WIDTH][GAMEMAP_HEIGH];

//
// BACKGROUND MAP ("BMED")
// 

#define BACKGROUNDMAP_WIDTH 60
#define BACKGROUNDMAP_HEIGH 48

unsigned char backgroundmap[BACKGROUNDMAP_WIDTH][BACKGROUNDMAP_HEIGH];

//
// EDITOR MAIN WINDOW
//

#define STARTING_LINE       16
#define HEIGHT_BEETWEENCELL 10
#define WIDTH_BEETWEENCELL  16
#define LINE_HEIGHT         32
#define START_COLOMN        10
#define TEXT_WIDTH          150
#define BUTTON_WIDTH_SMALL  50
#define BUTTON_HEIGH_SMALL  32

#define BUTTON_WIDTH_MEDIUM 100
#define BUTTON_WIDTH_LONG   200

enum {
  N_TEXT1=0,
  N_TEXT12, // Name of file
  N_BUT11, // Level Load
  N_BUT12, // Level Save

  N_TEXT2, // "Level Name"
  N_INP21, // Change

  N_TEXT3, // "Author"
  N_INP31, // Change

  N_TEXT4, // "Game Map"

  N_TEXT5, // "Game Map Name"
  N_TEXT52, // Name of file
  N_BUT51, // Load
  //N_BUT52, // Save
  N_BUT53, // Edit

  N_TEXT6,  // "Gfx Game"
  N_TEXT62, // Name of file
  N_BUT61,  // Load

  N_TEXT7, // "Background Map"

  N_TEXT8,  // "Background Map Name"
  N_TEXT82, // Name of file
  N_BUT81,  // Load
  //N_BUT82,  // Save
  N_BUT83,  // Edit

  N_TEXT9,  // "Gfx Background"
  N_TEXT92, // Name of file
  N_BUT91,  // Load

  N_TEXTA, // "BACKCOLORS"

  N_TEXTB,   // "BackColors"
  N_TEXTB2,  // Name of file
  N_BUTB1,   // Load
  N_BUTB2,   // View

  NUMBER_OF_BOX
};

#define WINDOW_WIDTH 760
#define WINDOW_HEIGH 680


//
// EDITOR GAME MAP WINDOW
//

// Index of boxes in GameMap Editor Window
enum {
  GMED_TEXT1=0,
  GMED_NUMBER_OF_BOX
};

// Each tile, has a set of info
struct tile_info {
  GLuint texture_id;           // Id of loaded texture
  int position_in_texture;  // Position in that texture (all texture are 16 pix heigh and cells are side by side)
  int size_of_texture;      // Position in that texture (all texture are 16 pix heigh and cells are side by side)
};

// All these infos are gathered into a table
// The id of the tile is also the index in this table (simple)
tile_info all_tiles[256];

#define GMED_MAIN_WIDTH  16 // Width in cell of main editing window
#define GMED_MAIN_HEIGH  16

#define GMED_TILE_WIDTH   8 // Width in cell of tile selection
//#define GMED_TILE1_HEIGH  6 // Heigh of first window
#define GMED_TILE1_HEIGH  15 // Heigh of first window
#define GMED_TILE2_HEIGH  8 // Height of second window

#define GMED_NUMBER_TILE_PAGES 3  // Number of differente tile pages

// Displayed tiles
// 0 = Uninitialised cell , 1-255 corresponds to different cells
unsigned char tile1pages[GMED_NUMBER_TILE_PAGES][GMED_TILE_WIDTH][GMED_TILE1_HEIGH];

unsigned char tile2pages[GMED_NUMBER_TILE_PAGES][GMED_TILE_WIDTH][GMED_TILE2_HEIGH];

#define DEFAULT_GAMESTYLE "bl1.gms"
//
// EDITOR BACKGROUND MAP WINDOW
//

// Index of boxes in BackgroundMap Editor Window
enum {
  BMED_TEXT1=0,
  BMED_NUMBER_OF_BOX
};

// All these infos are gathered into a table
// The id of the tile is also the index in this table (simple)
tile_info bmed_all_tiles[256];

#define BMED_MAIN_WIDTH  16 // Width in cell of main editing window
#define BMED_MAIN_HEIGH  16

#define BMED_TILE_WIDTH   8  // Width in cell of tile selection
#define BMED_TILE_HEIGH   15 // Heigh of first window

#define BMED_NUMBER_TILE_PAGES 3  // Number of differente tile pages

// Displayed tiles
// 0 = Uninitialised cell , 1-255 corresponds to different cells
unsigned char bmed_tilepages[BMED_NUMBER_TILE_PAGES][BMED_TILE_WIDTH][BMED_TILE_HEIGH];


//
// EDITOR MAP WINDOW - COMMON GLUT PARAMETERS
//

GLuint			tex_name[256];
int         actual_tex_name=0;
int         glutwindow_w; // Size of glut window
int         glutwindow_h;


void display_rectangle(int x, int y, int taillex, int tailley, float r, float g, float b);

// -----------------------------------------------
// Name : load_image
// LoadBMP : Load a 24bpp BMP file
// Bind it in a global 256 index array
// Return its index (int)
// -----------------------------------------------
int load_image(char *File)
{
	unsigned char	*Data;
	FILE			*fichier;
	unsigned char	Header[0x36];
	GLuint			DataPos,DataSize;
	GLint			Components;
	GLsizei			Width,Height;
	GLenum			Format,Type;
	
	unsigned char t;
	int	x;

	//Lit le fichier et son header
	fichier = fopen(File,"rb");
	if (!fichier) {
		printf("##Erreur## Fichier %s non trouve\n", File);
		return -1;
	}
  if (fread(Header,1,0x36,fichier)!=0x36) {
		printf("##Error## Not enough byte to read 0x36 header\n");
    EXIT;
  }
  if (Header[0]!='B' || Header[1]!='M')	{
		printf("##Error## header do not start with 'BM'\n");
    EXIT;
  }
  if (CTOI(Header[0x1E])!=0) {
		printf("##Error## header byte 0x1E is != 0\n");
    EXIT;
  }
  if (CTOI(Header[0x1C])!=24)	{
		printf("##Error## header byte 0x1C is != 24\n");
    EXIT;
  }

  //-- Rcupre les infos du fichier
	DataPos			= CTOI(Header[0x0A]);
	DataSize		= CTOI(Header[0x22]);
  //-- Rcupre les infos de l'image
	Width			= CTOI(Header[0x12]);
	Height			= CTOI(Header[0x16]);	
	Type = GL_UNSIGNED_BYTE;
	Format = GL_RGB;
	Components = 3;
	
	//!!!!
	if (DataSize==0)
    DataSize=Width*Height*Components;
	if (DataPos==0)
    DataPos=0x36;

  printf("Texture is %d x %d x %d\n", Width, Height, Components);

  //-- Charge l'image
	fseek(fichier,DataPos,0);
	Data = (unsigned char*) malloc(DataSize);
	if (!Data)
    EXIT;

	if (fread(Data,1,DataSize,fichier)!=DataSize) 
	{
		free(Data);
		fclose(fichier);
    printf("##ERROR## Image size not cohenrent\n");
		return -1;
	}
	
	fclose(fichier);

  //Inverse R et B
	for (x=0;x<Width*Height;x++) 
	{
		t=Data[x*3];
		Data[x*3]=Data[x*3+2];
		Data[x*3+2]=t;
	}

  //-- Envoie la texture  OpenGL
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	glBindTexture(GL_TEXTURE_2D, tex_name[actual_tex_name]);
	
	glTexImage2D
	( 	
		GL_TEXTURE_2D, 	//target
		0,				//mipmap level
		Components,		//nb couleurs
		Width,			//largeur
		Height,			//hauteur
		0,			 	//largeur du bord
		Format,			//type des couleurs
		Type,			//codage de chaque composante
		Data			//Image
	); 
	
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  printf("Image '%s' loaded\n", File);

  actual_tex_name++;
	return tex_name[actual_tex_name-1];
}




// ---------------------------------------------------------------------
//void req1_cb (Fl_Widget *, long)
//{
//  fc->show();
//}


// -----------------------------------------------
// -----------------------------------------------
void gmed_mouse(int b, int s, int x, int y)
{
  //printf("Mouse %d %d\n", x, y);

  // Mouse has been click
  // Find in which region we are

  // Main Window
  // -----------
  if ( (x>=0) && (x<GMED_MAIN_WIDTH*BS) && (y>=0) && (y<GMED_MAIN_HEIGH*BS) ) {

      // Put actual brick in game map (gamemap)
      //actual_choosen_tile
      gamemap[gmed_actual_scroll_cell_x + (x/BS)][gmed_actual_scroll_cell_y + (y/BS)]=actual_choosen_tile;
      glutPostRedisplay();
  }

  // Tile1 Window
  // -----------
  if ( (x>=(GMED_MAIN_WIDTH+1)*BS) && (x<(GMED_MAIN_WIDTH+1+GMED_TILE_WIDTH)*BS)
       && (y>0) && (y<GMED_TILE1_HEIGH*BS) ) {

      // Take a brick
      int cellx;
      int celly;
      cellx = x/BS;
      celly = y/BS;
      cellx=cellx - (GMED_MAIN_WIDTH+1);
    
      actual_choosen_tile=tile1pages[0][cellx][celly];
      //glutPostRedisplay();
  }
}


// -----------------------------------------------
// -----------------------------------------------
void bmed_mouse(int b, int s, int x, int y)
{
  // Mouse has been click
  // Find in which region we are

  // Main Window
  // -----------
  if ( (x>=0) && (x<BMED_MAIN_WIDTH*BS) && (y>=0) && (y<BMED_MAIN_HEIGH*BS) ) {

      // Put actual brick in background map
      backgroundmap[bmed_actual_scroll_cell_x+ (x/BS)][bmed_actual_scroll_cell_y + (y/BS)]=actual_choosen_tile;
      glutPostRedisplay();
  }

  // Tile Window
  // -----------
  if ( (x>=(BMED_MAIN_WIDTH+1)*BS) && (x<(BMED_MAIN_WIDTH+1+BMED_TILE_WIDTH)*BS)
       && (y>0) && (y<BMED_TILE_HEIGH*BS) ) {

      // Take a brick
      int cellx;
      int celly;
      cellx = x/BS;
      celly = y/BS;
      cellx=cellx - (BMED_MAIN_WIDTH+1);
    
      actual_choosen_tile=bmed_tilepages[0][cellx][celly];
  }
}

// -----------------------------------------------
// -----------------------------------------------
void bmed_special_keyboard(int key, int x, int y)
{
  //printf("Special Key %d %d %d\n", key, x, y);

  if (key==0x0FF51) {
    // Left
    bmed_actual_scroll_cell_x--;
  }
  if (key==0x0FF52) {
    // UP
   bmed_actual_scroll_cell_y--;
  }
  if (key==0x0FF53) {
    // Right
    bmed_actual_scroll_cell_x++;
  }
  if (key==0x0FF54) {
    // Down
    bmed_actual_scroll_cell_y++;
  }

  // Check if not out of bound
  if (bmed_actual_scroll_cell_x<0)
    bmed_actual_scroll_cell_x=0;
  if (bmed_actual_scroll_cell_y<0)
    bmed_actual_scroll_cell_y=0;

  if (bmed_actual_scroll_cell_x>GAMEMAP_WIDTH-BMED_MAIN_WIDTH)
    bmed_actual_scroll_cell_x=GAMEMAP_WIDTH-BMED_MAIN_WIDTH;
  if (bmed_actual_scroll_cell_y>GAMEMAP_HEIGH-BMED_MAIN_HEIGH)
    bmed_actual_scroll_cell_y=GAMEMAP_HEIGH-BMED_MAIN_HEIGH;

  glutPostRedisplay();        // Asked to redraw
}

void bmed_choose_cb (Fl_Widget *, long)
{
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose BackgroundMap file", "*.bm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(backgroundmap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(backgroundmap_name, newfile, FILENAME_SIZESMALL);

  fl_set_object_label(tobj[N_TEXT82], backgroundmap_name); // Put name into display cell
}

void bmsed_choose_cb (Fl_Widget *, long)
{
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose BackgroundMap Style file", "*.bms", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(backgroundstyle_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(backgroundstyle_name, newfile, FILENAME_SIZESMALL);

  fl_set_object_label(tobj[N_TEXT92], backgroundstyle_name); // Put name into display cell
}




void bcled_choose_cb(Fl_Widget *, long)
{
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose BackColors file", "*.bcl", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(backcolormap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(backcolormap_name, newfile, FILENAME_SIZESMALL);

  fl_set_object_label(tobj[N_TEXTB2], backcolormap_name); // Put name into display cell
}

unsigned char bcled_file[160*3]; // R V B * 160

void bcled_redraw(void)
{
  int i,j;

  glViewport (0, 0, glutwindow_w, glutwindow_h);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
	glOrtho(0, glutwindow_w, 0, glutwindow_h, -1, 1);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Draw Colors
  for (i=0; i<160; i++) {
    display_rectangle(0, i*2, 160, 2, (bcled_file[i*3]*8.0f)/255.0f, (bcled_file[(i*3)+1]*8.0f)/255.0f, (bcled_file[(i*3)+1]*8.0f)/255.0f);
  }
}
// ---------------------------------------------------------------------
void bcled_edit_cb (Fl_Widget *, long)
{
  Fl_Widget* obj;
  int        i;
  FILE*      file;

  if (backcolormap_name[0]==0)
    return;

  glutwindow_w = 160;
  glutwindow_h = 160*2;

  // -- Create FLTK window:
  Fl_Window window(glutwindow_w+10, glutwindow_h+10);

  window.show(NULL,NULL); // glut will die unless parent window visible 

  window.begin(); // this will cause Glut window to be a child
  glutInitWindowSize(glutwindow_w, glutwindow_h);
  glutInitWindowPosition(5,5); // place it inside parent window
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_MULTISAMPLE);
  glutCreateWindow("BackColors View");
  window.end(); 
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  //glutMouseFunc(bmed_mouse);
  glutDisplayFunc(bcled_redraw);
	//glutPassiveMotionFunc(processMousePassiveMotion);

  // Load file
  file=fopen(backcolormap_name, "rb");
  if (file!=NULL) {
    fread(&bcled_file, 1, 3*160, file);
    fclose(file);
  }



  glutMainLoop();
}


// -----------------------------------------------
// -----------------------------------------------
void affiche_image(GLuint id, int x, int y, int w, int h)
{

  int winW=glutwindow_w;
  int winH=glutwindow_h;

  y = winH - y;
	
	glBindTexture(GL_TEXTURE_2D, id);
  //printf("%d ", id);

	glEnable(GL_TEXTURE_2D);
	glColor3f(1, 1, 1);
	glBegin(GL_QUADS); // 1 Face Carree
		glTexCoord2i(0,0);
		glVertex2f(x,y-h);
		glTexCoord2i(1,0);
		glVertex2f(x+w,y-h);
		glTexCoord2i(1,1); 
		glVertex2f(x+w,y); 
		glTexCoord2i(0,1);
		glVertex2f(x,y);
	glEnd();

	glDisable(GL_TEXTURE_2D);
}

// display a BSxBS block (16x16 pixel) contained in a row of tiles

// -----------------------------------------------
// -----------------------------------------------
void display_cell(GLuint id, int x, int y, int position, int size)
{

  int winW=glutwindow_w;
  int winH=glutwindow_h;

  int w=BS;
  int h=BS;

  float uv_width;

  uv_width = 1.0f/(float)size; // Swidth of one cell in the image, in UV units (0.0f to 1.0f)

  y = winH - y;
	
	glBindTexture(GL_TEXTURE_2D, id);

	glEnable(GL_TEXTURE_2D);
	glColor3f(1, 1, 1);
	glBegin(GL_QUADS); // 1 Face Carree
		glTexCoord2f(position*uv_width,0);
		glVertex2f(x,y-h);
		glTexCoord2f((position+1)*uv_width,0);
		glVertex2f(x+w,y-h);
		glTexCoord2f((position+1)*uv_width,1); 
		glVertex2f(x+w,y); 
		glTexCoord2f(position*uv_width,1);
		glVertex2f(x,y);
	glEnd();

	glDisable(GL_TEXTURE_2D);
}

// -----------------------------------------------
// -----------------------------------------------
void display_rectangle(int x, int y, int taillex, int tailley, float r, float g, float b)
{
  int x1;
	int y1;
	int	x2;
	int y2;

  int winW=glutwindow_w;
  int winH=glutwindow_h;

	x1 = x;
	x2 = x + taillex;

	y1 = y;
	y2 = y + tailley;
	
	y1 = winH - y1;
	y2 = winH - y2;
	
	glDisable(GL_TEXTURE_2D);
	glColor3f(r, g, b);
	glBegin(GL_QUADS);
		glVertex2f(x1,y1);
		glVertex2f(x1,y2);
		glVertex2f(x2,y2); 
		glVertex2f(x2,y1);
	glEnd();
}

// -----------------------------------------------
// Name : gmed_redraw
// -----------------------------------------------
void gmed_redraw(void)
{
  int i,j;

  glViewport (0, 0, glutwindow_w, glutwindow_h);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
	glOrtho(0, glutwindow_w, 0, glutwindow_h, -1, 1);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Draw Tile Menu on left
  for (j=0; j<GMED_TILE1_HEIGH; j++) {
    for (i=0; i<GMED_TILE_WIDTH; i++) {
      unsigned char tile_id;
      tile_id=tile1pages[0][i][j];
      //printf("Tile id : %d Tex id : %d \n", tile_id, all_tiles[tile_id].texture_id);
      // TODO Manage size of texture and multiple tiles in one texture
      //affiche_image(all_tiles[tile_id].texture_id , (GMED_MAIN_WIDTH+1+i)*BS, j*BS, BS, BS);
      display_cell(all_tiles[tile_id].texture_id , (GMED_MAIN_WIDTH+1+i)*BS, j*BS, all_tiles[tile_id].position_in_texture, all_tiles[tile_id].size_of_texture);
    }
  }

  // Display MainWindow
  for (j=0; j<GMED_MAIN_HEIGH; j++) {
    for (i=0; i<GMED_MAIN_WIDTH; i++) {
      unsigned char tile_id;
      tile_id=gamemap[i+gmed_actual_scroll_cell_x][j+gmed_actual_scroll_cell_y];
      //printf("Tile id : %d Tex id : %d \n", tile_id, all_tiles[tile_id].texture_id);
      // TODO Manage size of texture and multiple tiles in one texture
      display_cell(all_tiles[tile_id].texture_id , i*BS, j*BS, all_tiles[tile_id].position_in_texture, all_tiles[tile_id].size_of_texture);
    }
  }

  // Display separation line
  display_rectangle( GMED_MAIN_WIDTH*BS, 0, BS, GMED_MAIN_HEIGH*BS, 0.865f, 0.865f, 0.865f);

  // Draw cursor
  glLineStipple(1, 0x3030);
  glEnable(GL_LINE_STIPPLE);
  glLineWidth(3.0);
  glColor3f(1, 0, 0);
  glBegin(GL_LINE_LOOP); // 1 Face Carree
	glVertex2f(actual_cell_x*BS,glutwindow_h-actual_cell_y*BS);
	glVertex2f((1+actual_cell_x)*BS,glutwindow_h-actual_cell_y*BS);
	glVertex2f((1+actual_cell_x)*BS,glutwindow_h-(1+actual_cell_y)*BS); 
	glVertex2f(actual_cell_x*BS,glutwindow_h-(1+actual_cell_y)*BS);
	glEnd();
  

  glutSwapBuffers();
}


// -----------------------------------------------
// Name : bmed_redraw
// -----------------------------------------------
void bmed_redraw(void)
{
  int i,j;

  glViewport (0, 0, glutwindow_w, glutwindow_h);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
	glOrtho(0, glutwindow_w, 0, glutwindow_h, -1, 1);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Draw Tile Menu on left
  for (j=0; j<BMED_TILE_HEIGH; j++) {
    for (i=0; i<BMED_TILE_WIDTH; i++) {
      unsigned char tile_id;
      tile_id=bmed_tilepages[0][i][j];
      display_cell(bmed_all_tiles[tile_id].texture_id , (GMED_MAIN_WIDTH+1+i)*BS, j*BS, bmed_all_tiles[tile_id].position_in_texture, bmed_all_tiles[tile_id].size_of_texture);
    }
  }

  // Display MainWindow
  for (j=0; j<BMED_MAIN_HEIGH; j++) {
    for (i=0; i<BMED_MAIN_WIDTH; i++) {
      unsigned char tile_id;
      tile_id=backgroundmap[bmed_actual_scroll_cell_x+i][bmed_actual_scroll_cell_y+j];
      display_cell(bmed_all_tiles[tile_id].texture_id , i*BS, j*BS, bmed_all_tiles[tile_id].position_in_texture, bmed_all_tiles[tile_id].size_of_texture);
    }
  }

  // Display separation line
  display_rectangle( BMED_MAIN_WIDTH*BS, 0, BS, BMED_MAIN_HEIGH*BS, 0.865f, 0.865f, 0.865f);

  // Draw cursor
  glLineStipple(1, 0x3030);
  glEnable(GL_LINE_STIPPLE);
  glLineWidth(3.0);
  glColor3f(1, 0, 0);
  glBegin(GL_LINE_LOOP); // 1 Face Carree
	glVertex2f(actual_cell_x*BS,glutwindow_h-actual_cell_y*BS);
	glVertex2f((1+actual_cell_x)*BS,glutwindow_h-actual_cell_y*BS);
	glVertex2f((1+actual_cell_x)*BS,glutwindow_h-(1+actual_cell_y)*BS); 
	glVertex2f(actual_cell_x*BS,glutwindow_h-(1+actual_cell_y)*BS);
	glEnd();
  
  glutSwapBuffers();
}

// -----------------------------------------------
// Name : processMousePassiveMotion
// If mouse is moved, then this callback is called
// -----------------------------------------------
void processMousePassiveMotion(int x, int y)
{
  int new_cell_x;
  int new_cell_y;

  actual_mouse_posx = x;
  actual_mouse_posy = y;

  // Compute new cell position
  new_cell_x = x / BS;
  new_cell_y = y / BS;

  if ( (new_cell_x==actual_cell_x) && (new_cell_y==actual_cell_y) ) {
    return;
  }
  
  actual_cell_x = new_cell_x; // Store new pos
  actual_cell_y = new_cell_y;

  glutPostRedisplay();        // Asked to redraw
}


void motion(int x, int y)
{
  //posx = x;
  //posy = y;
  glutPostRedisplay();
  //printf("Motion\n");
}


/*
void glutIdle (void)
{	
  //glutPostRedisplay ();
}
*/


// ---------------------------------------------------
//
// ---------------------------------------------------
void reset_tile_info_table()
{
  int i;
  for (i=0; i<256; i++) {
    all_tiles[i].texture_id=0;
    all_tiles[i].position_in_texture=-1;
    all_tiles[i].size_of_texture=-1;
  }
}


// ---------------------------------------------------
// Read first found char, and return it.
// Then get back in file to point on this caracter
// Skip space and carriage returns
// ---------------------------------------------------
char getfirstcar(FILE* file)
{
  char readchar;
  readchar=0x20;
  while ( (readchar==0x20) || (readchar==0x0a) )
    fread(&readchar, 1, 1, file);
  fseek(file, -1, SEEK_CUR);
  //printf("%02x\n", readchar);
  return readchar;
}

// ---------------------------------------------------
// Load tile
// Fill info table
// Fill menu selection
// ---------------------------------------------------
void gmed_init_tile(char* filename)
{
  FILE* file;
  int   i;


  file=fopen(filename, "r");

  if (file==NULL) {
    printf("##ERROR## Can not open file %s\n", filename);
    return;
  }

  int start_index;
  int number_of_tile;
  char texture_name[256];

  int position_in_menutile_x=0;
  int position_in_menutile_y=0;

  int image_id;;

  char text1[256];
  char text2[256];

  int page=0;   // index of page to fill



  while ( getfirstcar(file)!='!') {

    if ( getfirstcar(file) == '#' ) {
      //printf("This line is a comment\n");
      fgets(text1, 256, file);
    }
    else {

      fscanf(file, "%d %d %s %s", &start_index, &number_of_tile, &texture_name, &text1);
      
      // For each tile
      // Fill the info table and find a place in the menu page
      strcat(texture_name, ".bmp");
      image_id = load_image(texture_name);

      for (i=start_index; i<start_index+number_of_tile; i++) {
      
        // Fill info table
        all_tiles[i].texture_id=image_id;
        all_tiles[i].position_in_texture=i-start_index;
        all_tiles[i].size_of_texture=number_of_tile;

        printf("Tile %d init with image_id %d, pos %d, size %d\n", i, image_id, all_tiles[i].position_in_texture,all_tiles[i].size_of_texture);

        // Find a place in the menu selection
        //GMED_NUMBER_TILE_PAGES
        //GMED_TILE_WIDTH
        //GMED_TILE_HEIGH
        tile1pages[page][position_in_menutile_x][position_in_menutile_y]=i;
        
        position_in_menutile_x++;
        if (position_in_menutile_x>=GMED_TILE_WIDTH) {
          position_in_menutile_x=0;
          position_in_menutile_y++;
          if (position_in_menutile_y>=GMED_TILE1_HEIGH) {
            position_in_menutile_y=0;
            page++;
          }
        }



      }
      
      //printf("%d %d %s %s\n", a, b, text, text1);
    }
  }

  fclose(file);
}



// ---------------------------------------------------
// Load tile
// Fill info table
// Fill menu selection
// ---------------------------------------------------
void bmed_init_tile(char* filename)
{
  FILE* file;
  int   i;

  file=fopen(filename, "r");

  if (file==NULL) {
    printf("##ERROR## Can not open file %s\n", filename);
    return;
  }

  int start_index;
  int number_of_tile;
  char texture_name[256];

  int position_in_menutile_x=0;
  int position_in_menutile_y=0;

  int image_id;;

  char text1[256];
  char text2[256];

  int page=0;   // index of page to fill

  while ( getfirstcar(file)!='!') {

    if ( getfirstcar(file) == '#' ) {
      fgets(text1, 256, file);
    }
    else {

      fscanf(file, "%d %d %s %s", &start_index, &number_of_tile, &texture_name, &text1);
      
      // For each tile
      // Fill the info table and find a place in the menu page
      strcat(texture_name, ".bmp");
      image_id = load_image(texture_name);

      for (i=start_index; i<start_index+number_of_tile; i++) {
      
        // Fill info table
        bmed_all_tiles[i].texture_id=image_id;
        bmed_all_tiles[i].position_in_texture=i-start_index;
        bmed_all_tiles[i].size_of_texture=number_of_tile;

        printf("Tile %d init with image_id %d, pos %d, size %d\n", i, image_id, bmed_all_tiles[i].position_in_texture, bmed_all_tiles[i].size_of_texture);

        // Find a place in the menu selection
        //BMED_NUMBER_TILE_PAGES
        //BMED_TILE_WIDTH
        //BMED_TILE_HEIGH
        bmed_tilepages[page][position_in_menutile_x][position_in_menutile_y]=i;
        
        position_in_menutile_x++;
        if (position_in_menutile_x>=BMED_TILE_WIDTH) {
          position_in_menutile_x=0;
          position_in_menutile_y++;
          if (position_in_menutile_y>=BMED_TILE_HEIGH) {
            position_in_menutile_y=0;
            page++;
          }
        }
      }
      
    }
  }

  fclose(file);
}


void gmed_keyboard(unsigned char key, int x, int y)
{
  printf("Key %d %d %d\n", key, x, y);
}

void gmed_special_keyboard(int key, int x, int y)
{
  //printf("Special Key %d %d %d\n", key, x, y);

  if (key==0x0FF51) {
    // Left
    gmed_actual_scroll_cell_x--;
  }
  if (key==0x0FF52) {
    // UP
   gmed_actual_scroll_cell_y--;
  }
  if (key==0x0FF53) {
    // Right
    gmed_actual_scroll_cell_x++;
  }
  if (key==0x0FF54) {
    // Down
    gmed_actual_scroll_cell_y++;
  }

  // Check if not out of bound
  if (gmed_actual_scroll_cell_x<0)
    gmed_actual_scroll_cell_x=0;
  if (gmed_actual_scroll_cell_y<0)
    gmed_actual_scroll_cell_y=0;

  if (gmed_actual_scroll_cell_x>GAMEMAP_WIDTH-GMED_MAIN_WIDTH)
    gmed_actual_scroll_cell_x=GAMEMAP_WIDTH-GMED_MAIN_WIDTH;
  if (gmed_actual_scroll_cell_y>GAMEMAP_HEIGH-GMED_MAIN_HEIGH)
    gmed_actual_scroll_cell_y=GAMEMAP_HEIGH-GMED_MAIN_HEIGH;

  glutPostRedisplay();        // Asked to redraw
}

// -----------------------------------------------
// -----------------------------------------------
void gmed_load(Fl_Widget*)
{
  FILE* file;

  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose GameMap file", "*.gm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(gamemap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(gamemap_name, newfile, FILENAME_SIZESMALL);
  
  file=fopen(gamemap_name, "rb");
  if (file!=NULL) {
    fread(&gamemap, 1, GAMEMAP_WIDTH*GAMEMAP_HEIGH, file);
    fclose(file);
  }
}

// -----------------------------------------------
// -----------------------------------------------
void gmed_loadselected()
{
  FILE* file;

  if (gamemap_name[0]==0) // If no name entered then exit
    return;

  file=fopen(gamemap_name, "rb");
  if (file!=NULL) {
    fread(&gamemap, 1, GAMEMAP_WIDTH*GAMEMAP_HEIGH, file);
    fclose(file);
  }
}
// -----------------------------------------------
// -----------------------------------------------
void gmed_save(Fl_Widget*)
{
  FILE* file;
  
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose GameMap file", "*.gm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(gamemap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(gamemap_name, newfile, FILENAME_SIZESMALL);
  
  file=fopen(gamemap_name, "wb");
  if (file!=NULL) {
    fwrite(&gamemap, 1, GAMEMAP_WIDTH*GAMEMAP_HEIGH, file);
    fclose(file);
  }
}

Fl_Output* gmed_InfoBox;
Fl_Button* gmed_LoadBox;
Fl_Button* gmed_SaveBox;

// ---------------------------------------------------------------------
// -----------------------------------------------
void gmed_edit_cb (Fl_Widget *, long)
{
  Fl_Widget* obj;
  int        i;

  gmed_actual_scroll_cell_x=0;
  gmed_actual_scroll_cell_y=0;

  reset_tile_info_table();

  glutwindow_w = (GMED_MAIN_WIDTH+1+GMED_TILE_WIDTH)*BS;
  glutwindow_h = (GMED_MAIN_HEIGH)*BS;

  // -- Create FLTK window:
  Fl_Window window(glutwindow_w+20, glutwindow_h+150);

  // -- Create Buttons
  gmed_InfoBox = new Fl_Output(START_COLOMN+TEXT_WIDTH,glutwindow_h+90+16,BUTTON_WIDTH_LONG,LINE_HEIGHT,"Infos");
  gmed_InfoBox->value("This is a text");

  gmed_LoadBox = new Fl_Button(START_COLOMN,STARTING_LINE,BUTTON_WIDTH_MEDIUM,LINE_HEIGHT,"Load Map");
  gmed_LoadBox->callback(gmed_load);
  gmed_SaveBox = new Fl_Button(START_COLOMN+BUTTON_WIDTH_MEDIUM+WIDTH_BEETWEENCELL,STARTING_LINE,BUTTON_WIDTH_MEDIUM,LINE_HEIGHT,"Save Map");
  gmed_SaveBox->callback(gmed_save);  

  window.show(NULL,NULL); // glut will die unless parent window visible 

  window.begin(); // this will cause Glut window to be a child
  glutInitWindowSize(glutwindow_w, glutwindow_h);
  glutInitWindowPosition(10,90); // place it inside parent window
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_MULTISAMPLE);
  glutCreateWindow("Game Map Edit");
  window.end(); 
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  glutMouseFunc(gmed_mouse);
  glutDisplayFunc(gmed_redraw);
  //glutIdleFunc (glutIdle);
  //glutMotionFunc(motion);
	glutPassiveMotionFunc(processMousePassiveMotion);
  glutKeyboardFunc(gmed_keyboard);
  glutSpecialFunc(gmed_special_keyboard);


  glGenTextures(256, &tex_name[0]);

  // Load a map if user selected one
  gmed_loadselected();

  // Load a gamestyle if user selected one
  if (gamestyle_name[0]!=0)
    gmed_init_tile(gamestyle_name);
  else
    gmed_init_tile(DEFAULT_GAMESTYLE);


  glutMainLoop();
}


// -----------------------------------------------
// -----------------------------------------------
void bmed_load(Fl_Widget*)
{
  FILE* file;

  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose BackgroundMap file", "*.bm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(backgroundmap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(backgroundmap_name, newfile, FILENAME_SIZESMALL);


  file=fopen(backgroundmap_name, "rb");
  if (file!=NULL) {
    fread(&backgroundmap, 1, BACKGROUNDMAP_WIDTH*BACKGROUNDMAP_HEIGH, file);
    fclose(file);
  }


}

// -----------------------------------------------
// -----------------------------------------------
void bmed_loadselected()
{
  FILE* file;

  if ( backgroundmap_name[0]==0 ) {
    return;
  }
  
  file=fopen(backgroundmap_name, "rb");
  if (file!=NULL) {
    fread(&backgroundmap, 1, BACKGROUNDMAP_WIDTH*BACKGROUNDMAP_HEIGH, file);
    fclose(file);
  }
}

// -----------------------------------------------
// -----------------------------------------------
void bmed_save(Fl_Widget*)
{
  FILE* file;

  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose BackgroundMap file", "*.bm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(backgroundmap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(backgroundmap_name, newfile, FILENAME_SIZESMALL);

  file=fopen(backgroundmap_name, "wb");
  if (file!=NULL) {
    fwrite(&backgroundmap, 1, BACKGROUNDMAP_WIDTH*BACKGROUNDMAP_HEIGH, file);
    fclose(file);
  }


}

Fl_Output* bmed_InfoBox;
Fl_Button* bmed_LoadBox;
Fl_Button* bmed_SaveBox;


// ---------------------------------------------------------------------
void bmed_edit_cb (Fl_Widget *, long)
{
  Fl_Widget* obj;
  int        i;

  //reset_tile_info_table();
  gmed_actual_scroll_cell_x=0;
  gmed_actual_scroll_cell_y=0;

  glutwindow_w = (GMED_MAIN_WIDTH+1+GMED_TILE_WIDTH)*BS;
  glutwindow_h = (GMED_MAIN_HEIGH)*BS;

  // -- Create FLTK window:
  Fl_Window window(glutwindow_w+20, glutwindow_h+150);

  // -- Create Buttons
  bmed_InfoBox = new Fl_Output(START_COLOMN+TEXT_WIDTH,glutwindow_h+90+16,BUTTON_WIDTH_LONG,LINE_HEIGHT,"Infos");
  bmed_InfoBox->value("This is a text");

  bmed_LoadBox = new Fl_Button(START_COLOMN,STARTING_LINE,BUTTON_WIDTH_MEDIUM,LINE_HEIGHT,"Load Map");
  bmed_LoadBox->callback(bmed_load);
  bmed_SaveBox = new Fl_Button(START_COLOMN+BUTTON_WIDTH_MEDIUM+WIDTH_BEETWEENCELL,STARTING_LINE,BUTTON_WIDTH_MEDIUM,LINE_HEIGHT,"Save Map");
  bmed_SaveBox->callback(bmed_save);  

  window.show(NULL,NULL); // glut will die unless parent window visible 

  window.begin(); // this will cause Glut window to be a child
  glutInitWindowSize(glutwindow_w, glutwindow_h);
  glutInitWindowPosition(10,90); // place it inside parent window
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_MULTISAMPLE);
  glutCreateWindow("Background Map Edit");
  window.end(); 
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  glutMouseFunc(bmed_mouse);
  glutDisplayFunc(bmed_redraw);
	glutPassiveMotionFunc(processMousePassiveMotion);
  glutSpecialFunc(bmed_special_keyboard);

  glGenTextures(256, &tex_name[0]);
  
  bmed_loadselected();

  if (backgroundstyle_name[0]==0)
    strcpy(backgroundstyle_name, "bg1.bms");
  
  bmed_init_tile(backgroundstyle_name);

  glutMainLoop();
}


void gmed_choose_cb (Fl_Widget *, long)
{
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose GameMap file", "*.gm", NULL);

  if (newfile==NULL)
    return;

  p=strrchr(newfile, '/');
  if (p)
    strncpy(gamemap_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(gamemap_name, newfile, FILENAME_SIZESMALL);

  fl_set_object_label(tobj[N_TEXT52], gamemap_name); // Put name into display cell
}

void gmsed_choose_cb (Fl_Widget *, long)
{
  char* newfile;
  char* p;
  newfile = fl_file_chooser("Choose GameMap Style file", "*.gms", NULL);

  if (newfile==NULL)
    return;


  p=strrchr(newfile, '/');
  if (p)
    strncpy(gamestyle_name, p+1, FILENAME_SIZESMALL);
  else
    strncpy(gamestyle_name, newfile, FILENAME_SIZESMALL);

  fl_set_object_label(tobj[N_TEXT62], gamestyle_name); // Put name into display cell
}

/*************** Creation Routines *********************/
void create_form_form (void)
{
  Fl_Widget* obj;
  int        i;

  form = fl_bgn_form(FL_NO_BOX, WINDOW_WIDTH, WINDOW_HEIGH);
  
  // Create border

  obj = fl_add_box(FL_UP_BOX, 0, 0, WINDOW_WIDTH, WINDOW_HEIGH, "");
  fl_set_object_color(obj, FL_COL1, FL_COL1);
  
  //obj = fl_add_box(FL_DOWN_BOX, 10, 90, 700, 420, "");
  //fl_set_object_color(obj, FL_COL1, FL_COL1);
  
  //obj = fl_add_box(FL_DOWN_BOX, 10, 10, 700, 70, "");
  //fl_set_object_color(obj, FL_SLATEBLUE, FL_COL1);
  
  
  tobj[N_TEXT1]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE,TEXT_WIDTH, LINE_HEIGHT, "LEVEL");
  fl_set_object_lcol(tobj[N_TEXT1], FL_RED);
  fl_set_object_lalign(tobj[N_TEXT1], FL_ALIGN_CENTER);

  tobj[N_TEXT12]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");
  
  
  tobj[N_BUT11]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE,
    BUTTON_WIDTH_SMALL, BUTTON_HEIGH_SMALL, "LOAD");
  
  tobj[N_BUT12]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_SMALL+BUTTON_WIDTH_LONG, STARTING_LINE,
    BUTTON_WIDTH_SMALL, BUTTON_HEIGH_SMALL, "SAVE");
  //fl_set_object_label(tobj[1], "MyText is very much longer than I tought");

  // -- "Level Name"
  // Change

  tobj[N_TEXT2]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+BUTTON_HEIGH_SMALL+HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "LEVEL NAME");
  
  tobj[N_INP21]=obj=fl_add_input(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+BUTTON_HEIGH_SMALL+HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, BUTTON_HEIGH_SMALL, "");

  // -- "Author"
  // Change

  tobj[N_TEXT3]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+2*BUTTON_HEIGH_SMALL+2*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "AUTHOR");
  
  tobj[N_INP31]=obj=fl_add_input(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+2*BUTTON_HEIGH_SMALL+2*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, BUTTON_HEIGH_SMALL, "");


  // -- "Game Map"
  // ---------------------
  tobj[N_TEXT4]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+3*BUTTON_HEIGH_SMALL+3*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "GAME MAP");
  fl_set_object_lcol(tobj[N_TEXT4], FL_RED);
  fl_set_object_lalign(tobj[N_TEXT4], FL_ALIGN_CENTER);


  // "Game Map File"
  // ---------------------
  tobj[N_TEXT5]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+4*BUTTON_HEIGH_SMALL+4*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "Game map file");

  tobj[N_TEXT52]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+4*BUTTON_HEIGH_SMALL+4*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");

  // GameMap Choose
  // ---------------------
  tobj[N_BUT51]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE+4*BUTTON_HEIGH_SMALL+4*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_MEDIUM, BUTTON_HEIGH_SMALL, "CHOOSE");
  
  //tobj[N_BUT52]=obj=fl_add_button(FL_NORMAL_BUTTON,
  //  START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_SMALL+BUTTON_WIDTH_LONG, STARTING_LINE+4*BUTTON_HEIGH_SMALL+4*HEIGHT_BEETWEENCELL,
  //  BUTTON_WIDTH_SMALL, BUTTON_HEIGH_SMALL, "SAVE");

  tobj[N_BUT53]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG+BUTTON_WIDTH_MEDIUM, STARTING_LINE+4*BUTTON_HEIGH_SMALL+4*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, BUTTON_HEIGH_SMALL, "EDIT");

  fl_set_object_callback (tobj[N_BUT53], gmed_edit_cb, 0);


  // "Game Style Filename"
  // ---------------------
  tobj[N_TEXT6]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+5*BUTTON_HEIGH_SMALL+5*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "Game GFX file");

  tobj[N_TEXT62]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+5*BUTTON_HEIGH_SMALL+5*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");

  // Choose Game style
  tobj[N_BUT61]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE+5*BUTTON_HEIGH_SMALL+5*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_MEDIUM, BUTTON_HEIGH_SMALL, "CHOOSE");
  


  // -- "Background Map"
  // ---------------------

  tobj[N_TEXT7]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+6*BUTTON_HEIGH_SMALL+6*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "BACKGROUND MAP");
  fl_set_object_lcol(tobj[N_TEXT7], FL_RED);
  fl_set_object_lalign(tobj[N_TEXT7], FL_ALIGN_CENTER);

  // "Bakcground Map File"
  // ---------------------

  tobj[N_TEXT8]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+7*BUTTON_HEIGH_SMALL+7*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "Background map file");

  tobj[N_TEXT82]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+7*BUTTON_HEIGH_SMALL+7*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");

  tobj[N_BUT81]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE+7*BUTTON_HEIGH_SMALL+7*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_MEDIUM, BUTTON_HEIGH_SMALL, "CHOOSE");
  
  //tobj[N_BUT82]=obj=fl_add_button(FL_NORMAL_BUTTON,
  //  START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_SMALL+BUTTON_WIDTH_LONG, STARTING_LINE+7*BUTTON_HEIGH_SMALL+7*HEIGHT_BEETWEENCELL,
  //  BUTTON_WIDTH_SMALL, BUTTON_HEIGH_SMALL, "SAVE");

  tobj[N_BUT83]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG+BUTTON_WIDTH_MEDIUM, STARTING_LINE+7*BUTTON_HEIGH_SMALL+7*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, BUTTON_HEIGH_SMALL, "EDIT");
  
  fl_set_object_callback (tobj[N_BUT83], bmed_edit_cb, 0);

  // "Gfx Filename"
  tobj[N_TEXT9]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+8*BUTTON_HEIGH_SMALL+8*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "Background GFX file");

  tobj[N_TEXT92]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+8*BUTTON_HEIGH_SMALL+8*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");

  tobj[N_BUT91]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE+8*BUTTON_HEIGH_SMALL+8*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_MEDIUM, BUTTON_HEIGH_SMALL, "CHOOSE");


  // -- "Back Colors"
  // ------------------
  tobj[N_TEXTA]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+9*BUTTON_HEIGH_SMALL+9*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "BACKCOLORS");
  fl_set_object_lcol(tobj[N_TEXTA], FL_RED);
  fl_set_object_lalign(tobj[N_TEXTA], FL_ALIGN_CENTER);


  // "Backcolors file"
  tobj[N_TEXTB]=obj=fl_add_text(FL_NORMAL_TEXT,
    START_COLOMN, STARTING_LINE+10*BUTTON_HEIGH_SMALL+10*HEIGHT_BEETWEENCELL,
    TEXT_WIDTH, LINE_HEIGHT, "Backcolors file");

  // Name of file
  tobj[N_TEXTB2]=obj=fl_add_text(FL_NORMAL_TEXT,      // Name of level file
    START_COLOMN+TEXT_WIDTH+WIDTH_BEETWEENCELL, STARTING_LINE+10*BUTTON_HEIGH_SMALL+10*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, LINE_HEIGHT, "");

  tobj[N_BUTB1]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+2*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG, STARTING_LINE+10*BUTTON_HEIGH_SMALL+10*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_MEDIUM, BUTTON_HEIGH_SMALL, "CHOOSE");

  tobj[N_BUTB2]=obj=fl_add_button(FL_NORMAL_BUTTON,
    START_COLOMN+TEXT_WIDTH+3*WIDTH_BEETWEENCELL+BUTTON_WIDTH_LONG+BUTTON_WIDTH_MEDIUM, STARTING_LINE+10*BUTTON_HEIGH_SMALL+10*HEIGHT_BEETWEENCELL,
    BUTTON_WIDTH_LONG, BUTTON_HEIGH_SMALL, "VIEW");

  fl_set_object_callback (tobj[N_BUTB2], bcled_edit_cb, 0);
  


  
  exitob=obj= fl_add_button (FL_NORMAL_BUTTON,
    WINDOW_WIDTH-START_COLOMN-BUTTON_WIDTH_SMALL, STARTING_LINE,
    BUTTON_WIDTH_SMALL, BUTTON_HEIGH_SMALL, "EXIT");
  


   for (i = 0; i < NUMBER_OF_BOX; i++)
      fl_set_object_boxtype (tobj[i], (Fl_Boxtype)FL_PLASTIC_UP_BOX);

   fl_set_object_boxtype (tobj[N_INP21], (Fl_Boxtype)FL_PLASTIC_DOWN_BOX);
   fl_set_object_boxtype (tobj[N_INP31], (Fl_Boxtype)FL_PLASTIC_DOWN_BOX);

   fl_set_object_callback (tobj[N_BUT51], gmed_choose_cb, 0);
   fl_set_object_callback (tobj[N_BUT61], gmsed_choose_cb, 0);

   fl_set_object_callback (tobj[N_BUT81], bmed_choose_cb, 0);
   fl_set_object_callback (tobj[N_BUT91], bmsed_choose_cb, 0);

   fl_set_object_callback (tobj[N_BUTB1], bcled_choose_cb, 0);

   fl_end_form ();
}



// -------------------------------------------------------------------
// Name : main
// -------------------------------------------------------------------
int main (int argc, char *argv[])
{


  fl_initialize(&argc, argv, "EditorCK", 0, 0);
  
  fc = new Fl_File_Chooser(".", "*", Fl_File_Chooser::SINGLE, "Fl_File_Chooser Test");
  fc->callback(fc_callback); 

  create_form_form();

  fl_show_form (form, FL_PLACE_MOUSE, border, "Box types");

  printf("Test\n");

  while (fl_do_forms () != exitob)
     ;

  return 0;
}



void fc_callback(Fl_File_Chooser* fc,	void* data)
{
  const char* filename;	// Current filename
  printf("fc_callback(fc = %p, data = %p)\n", fc, data);
  filename = fc->value();
  //printf("    filename = \"%s\"\n", filename ? filename : "(null)");
  //fl_set_object_label(tobj[1], filename);
  strcpy(filechoosen, filename);
} 